#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include "cquad.h"

double fun(double x);

int main()
{
    double a, b, epsabs, epsrel, result, abserr, *alist, *blist, *rlist, *elist;
    int neval, ier, key, last, *iord;
 
 // a and b are the integration limits
    a = 0;
    b = M_PI;    // M_PI is the constant for Pi (greek letter P)

 // epsabs and epsrel determine the accuracy requirement    
    epsabs = 0;
    epsrel = 0.001;
 
 // key determines the integration rule used in cquad_dqage
    key = 6;

 // allocate memory
    iord = (int *) calloc(LIMIT, sizeof(int));
    alist = (double *) calloc(LIMIT, sizeof(double));
    blist = (double *) calloc(LIMIT, sizeof(double));
    rlist = (double *) calloc(LIMIT, sizeof(double));
    elist = (double *) calloc(LIMIT, sizeof(double));
 
    result = cquad_dqage(fun, a, b, epsabs, epsrel, key, &abserr, &neval, &ier, alist, blist, rlist, elist, iord, &last);
 
 // print the result
    printf("\nFunction:  cos(100 * sin(x))  over [0, Pi]\n");
    printf("\nIntegral approximation:            %lg\n", result);
    printf("Estimate of absolute error:        %lg\n", abserr);
    printf("Number of function evaluations:    %d\n", neval);
    printf("Error code:  %d\n\n", ier);

 // free allocated memory 
    free(iord);
    free(alist);
    free(blist);
    free(rlist);
    free(elist);
}
